#ifndef SSHCONF_H
#define SSHCONF_H
@TOP@

/* Package name. */
#undef PACKAGE

/* Package version. */
#undef VERSION

/* EFENCE memory debugger */
#undef EFENCE

/* Light debugging */
#undef DEBUG_LIGHT

/* Heavy debugging */
#undef DEBUG_HEAVY

/* Inet addr is broken on this system */
#undef BROKEN_INET_ADDR

/* Sizes of usermode basic types */
#undef USERMODE_SIZEOF_INT
#undef USERMODE_SIZEOF_LONG
#undef USERMODE_SIZEOF_LONG_LONG
#undef USERMODE_SIZEOF_SHORT
#undef USERMODE_SIZEOF_VOID_P

/* "Have" for the usermode types */
#undef HAVE_USERMODE_INT
#undef HAVE_USERMODE_LONG
#undef HAVE_USERMODE_LONG_LONG
#undef HAVE_USERMODE_SHORT
#undef HAVE_USERMODE_VOID_P

/* Is this source tree compiled with purify? */
#undef WITH_PURIFY

/* Are development time memory leak checks enabled? */
#undef MEMORY_LEAK_CHECKS

/* Stack trace support for memory leaks? */
#undef MEMORY_LEAK_STACK_TRACE
#undef MEMORY_LEAK_STACK_TRACE_I386_GCC

/* How large data and insn caches do we have, in kB. */
#undef SSH_DATA_CACHE_SIZE
#undef SSH_INSN_CACHE_SIZE

/* PCSC libraries */
#undef HAVE_PCSC

/* Define this for Hi/Fn 6500 support */
#undef WITH_HIFN6500

/* Define this to build sshscheme. */
#undef WITH_SCHEME

/* This is defined if /var/run exists. */
#undef HAVE_VAR_RUN

/* Define this to enable setting TCP_NODELAY for tcp sockets. */
#undef ENABLE_TCP_NODELAY

/* Define this if connect(2) system call fails with nonblocking sockets. */
#undef NO_NONBLOCKING_CONNECT

/* Define this if S_IFSOCK is defined */
#undef HAVE_S_IFSOCK

/* Define this if you are using HP-UX.  HP-UX uses non-standard shared
   memory communication for X, which seems to be enabled by the display name
   matching that of the local host.  This circumvents it by using the IP
   address instead of the host name in DISPLAY. */
#undef HPUX_NONSTANDARD_X11_KLUDGE

/* Support for Secure RPC */
#undef SECURE_RPC

/* Support for Secure NFS */
#undef SECURE_NFS

/* Does struct tm have tm_gmtoff member? */
#undef HAVE_TM_GMTOFF_IN_STRUCT_TM

/* Does struct tm have __tm_gmtoff__ member? (older Linux distributions) */
#undef HAVE_OLD_TM_GMTOFF_IN_STRUCT_TM

/* Does struct tm have tm_isdst member? */
#undef HAVE_TM_ISDST_IN_STRUCT_TM

/* Does system keep gmt offset in external variable "timezone"? */
#undef HAVE_EXTERNAL_TIMEZONE

/* Should sshtime routines avoid using system provided gmtime(3)
   and localtime(3) functions? */
#undef USE_SSH_INTERNAL_LOCALTIME

/* Do we have POSIX style accept(2), send(2), sendto(2), recv(2),
   recvfrom(2), getsockopt(2), setsockopt(2), getpeername(2),
   getsockneme(2) and other socket call prototypes
   with argument pointing address representation length 
   size as size_t instead of the old ones (still present in most of 
   the systems) with int type argument? */
#undef HAVE_POSIX_STYLE_SOCKET_PROTOTYPES

/* Do we have threads? */
#undef HAVE_THREADS

/* Do we have posix threads */
#undef HAVE_PTHREADS

/* Do we have IPv6 socket structures */
#undef HAVE_SOCKADDR_IN6_STRUCT

/* Whether termios.h needs modem.h to also be included in
   sshserialstream. */
#undef TERMIOS_H_NEEDS_MODEM_H

/* Define this to enable IPv6 support. */
#undef WITH_IPV6

/* Whether we can use __attribute__ ((weak)) with GCC */
#undef HAVE_GCC_ATTRIBUTE_WEAK

/* Define this to use assembler routines in sshmath library. */
#undef SSHMATH_ASSEMBLER_SUBROUTINES

/* Define this to use assembler macros in sshmath library. */
#undef SSHMATH_ASSEMBLER_MACROS

/* Define this to use i386 assembler routines in sshmath library. */
#undef SSHMATH_I386

/* Define this to use alpha assembler routines in sshmath library. */
#undef SSHMATH_ALPHA

/* Define this to use Digital CC V5.3 assembler inline macros in sshmath
library. */
#undef SSHMATH_ALPHA_DEC_CC_ASM

/* Define this so that modular exponentation assumes an odd modulus. */
#undef SSHMATH_ODD_MODULUS


/* Define this, if /usr/xpg4/include/term.h is to be used instead of
   /usr/include/term.h */
#undef HAVE_USR_XPG4_INCLUDE_TERM_H

/* Define this, if you have newer terminfo (instead of obsolete
   termcap) */
#undef HAVE_TERMINFO

/* Define this if you have setpgid() (replaces setpgrp) */
#undef HAVE_SETPGID

/* Define this if O_NONBLOCK does not work on your system (e.g., Ultrix). */
#undef O_NONBLOCK_BROKEN

/* Define this if speed_t is defined in stdtypes.h or otherwise gets included
   into ttymodes.c from system headers. */
#undef SPEED_T_IN_STDTYPES_H

/* If defines, this overrides "tty" as the terminal group. */
#undef TTY_GROUP

#ifdef SSHDIST_SESSION_SIA
/* Define if you have SIA, Security Integration Architecture (as in
   Tru64 UNIX). */
#undef HAVE_SIA
#endif /* SSHDIST_SESSION_SIA */

/* Define this if your system has minor */
#undef HAVE_MINOR

/* Define this if spwd has member sp_expire*/
#undef HAVE_STRUCT_SPWD_EXPIRE

/* Define this if spwd has member sp_inact */
#undef HAVE_STRUCT_SPWD_INACT

/* Define this if utmpx has member ut_syslen */
#undef HAVE_SYSLEN_IN_UTMPX

/* Define this if utmpx has member ut_session */
#undef HAVE_SESSION_IN_UTMPX

/* Define this if utmpx has member ut_pid */
#undef HAVE_PID_IN_UTMPX

/* Define if utmp structure has addr field. */
#undef HAVE_ADDR_IN_UTMP

/* Define if utmp structure has id field. */
#undef HAVE_ID_IN_UTMP

/* Define if utmp structure has name field. */
#undef HAVE_NAME_IN_UTMP

/* Define if utmp structure has pid field. */
#undef HAVE_PID_IN_UTMP

/* Define if utmp structure has type field. */
#undef HAVE_TYPE_IN_UTMP

/* Define if you have shadow passwords in /etc/security/passwd (AIX style). */
#undef HAVE_ETC_SECURITY_PASSWD

/* Define if you have shadow passwords in /etc/security/passwd.adjunct
   (SunOS style). */
#undef HAVE_ETC_SECURITY_PASSWD_ADJUNCT
  
/* Define if you have shadow passwords in /etc/shadow (Solaris style). */
#undef HAVE_ETC_SHADOW

/* Define if you have system login defaults in /etc/default/login. */
#undef HAVE_ETC_DEFAULT_LOGIN

/* Define these if on SCO Unix. */
#undef HAVE_SCO_ETC_SHADOW
#undef SCO

/* Define this if compiling on Ultrix.  Defining this does not actually require
   shadow passwords to be present; this just includes support for them. */
#undef HAVE_ULTRIX_SHADOW_PASSWORDS

/* Define this for HP-UX 10.x shadow passwords */
#undef HAVE_HPUX_TCB_AUTH

/* Define if utmp structure has host field. */
#undef HAVE_HOST_IN_UTMP

/* Default path for utmp.  Determined by configure. */
#undef SSH_UTMP

/* Default path for wtmp.  Determined by configure. */
#undef SSH_WTMP

/* Default path for lastlog.  Determined by configure. */
#undef SSH_LASTLOG

/* This is defined if we found a lastlog file.  The presence of lastlog.h
   alone is not a sufficient indicator (at least newer BSD systems have
   lastlog but no lastlog.h. */
#undef HAVE_LASTLOG

/* Define if /var/adm/lastlog or whatever it is called is a directory
   (e.g. SGI IRIX). */
#undef LASTLOG_IS_DIR

/* Define this if libutil.a contains BSD 4.4 compatible login(), logout(),
   and logwtmp() calls. */
#undef HAVE_LIBUTIL_LOGIN

/* Location of system mail spool directory. */
#undef MAIL_SPOOL_DIRECTORY

/* Name of user's mail spool file if stored in user's home directory. */
#undef MAIL_SPOOL_FILE

/* Support for NIS+ */
#undef NIS_PLUS

/* Define this if a prototype for login() is defined in system headers. */
#undef HAVE_PROTO_LOGIN

/* Define this if a prototype for logout() is defined in system headers. */
#undef HAVE_PROTO_LOGOUT

/* Define this if a prototype for logwtmp() is defined in system headers. */
#undef HAVE_PROTO_LOGWTMP

/* Define this if a prototype for initgroups() is defined in system headers. */
#undef HAVE_PROTO_INITGROUPS

/* Define this if your system has Kerberos5 installed. */
#undef KERBEROS

/* Define if your system defines struct lastlog in login.h. */
#undef STRUCT_LASTLOG_DEFINED_IN_LOGIN_H

/* Enable PGP library. */
#undef WITH_PGP


/* Define this to the canonical name of your host type (e.g., 
   "sparc-sun-sunos4.0.3"). */
#undef HOSTTYPE

/* Define this to be the path of the rsh program to support executing rsh. */
#undef RSH_PATH

/* Define this to be the path of the xauth program. */
#undef XAUTH_PATH

/* Define this if your Xserver supports the SECURITY extension. */
#undef HAVE_X11_EXTENSIONS_SECURITY

/* Define this to be the default user path if you don't like the default. 
   See the --with-path=<path> configure option. */
#undef DEFAULT_PATH

/* Define this if sys/syslog.h needs to be included in addition to syslog.h.
   This is the case on some Ultrix versions. */
#undef NEED_SYS_SYSLOG_H

/* Define this to include libwrap (tcp_wrappers) support. */
#undef LIBWRAP
#undef HAVE_LIBWRAP

/* This is defined to pw_encrypt on Linux when using John Faugh's shadow 
   password implementation. */
#undef crypt

/* Define this if you want the server to support SecurID authentication */
#undef SSH_SERVER_WITH_SECURID

/* Define this if you have old-style (4.x or older) SecurID ACE API.  */
#undef HAVE_OLD_RSA_ACE_API

/* Define this if you want the client to support SecurID authentication */
#undef SSH_CLIENT_WITH_SECURID

/* PAM support. */
/* Define this if you want sshd2 support PAM. */
#undef DAEMON_WITH_PAM

/* Define this if you want ssh2 support PAM. */
#undef CLIENT_WITH_PAM

/* Define this if your system has the PAM libraries (libpamc and
   <security/pam_client.h>. */
#undef CLIENT_WITH_PAMC_LIBS

/* Define this to the service name you want sshd2 to use with PAM. */
#undef SSH_PAM_SERVICE_NAME

/* Define this if you want ssh2 to use "keyboard-interactive"
   authentication method. */
#undef SSH_CLIENT_WITH_KEYBOARD_INTERACTIVE

/* Define this if you want sshd2 to use "keyboard-interactive"
   authentication method. */
#undef SSH_SERVER_WITH_KEYBOARD_INTERACTIVE

/* Define this if you want to support TIS Authentication scheme. */
#undef HAVE_TIS

/* Directory containing ssh_config, ssh_known_hosts, sshd_pid, etc.  Normally
   /etc. */
#undef ETCDIR

/* Additionally define this if on SCO 3.2v5 Unix */
#undef SCO5

/* Define this if you have setpgid() (replaces setpgrp) */
#undef HAVE_SETPGID

/* Define this if you want to disable port forwardings */
#undef DISABLE_PORT_FORWARDING

/* Define this if you want to disable X11 forwarding */
#undef DISABLE_X11_FORWARDING

/* Set this to allow group writeability of $HOME, .ssh and authorized_keys */
#undef ALLOW_GROUP_WRITEABILITY

/* Define this if inet_network should be used instead of inet_addr.  This is
   the case on DGUX 5.4. */
#undef BROKEN_INET_ADDR

/* Name of the X11 directory (/{tmp,var/X}/.X11-{unix,pipe}) as a string. */
#undef X11_DIR

/* Define this if there is a compatible ssh 1.x, and SSH1_PATH, SCP1_PATH,
   and SSHD1_PATH have been set to the appropriate path. */
#undef SSH1_COMPATIBILITY

/* Path for compatible ssh 1.x. */
#undef SSH1_PATH

/* Path for compatible sshd 1.x. */
#undef SSHD1_PATH

/* Path for compatible scp 1.x. */
#undef SCP1_PATH

#ifdef SSHDIST_SSH2_INTERNAL_SSH1_EMULATION
/* Enable internal ssh1 compatibility. */
#undef WITH_INTERNAL_SSH1_EMULATION
#endif /* SSHDIST_SSH2_INTERNAL_SSH1_EMULATION */

/* Enable ssh-agent1 compatibility in ssh-agent2. */
#undef WITH_SSH_AGENT1_COMPAT

/* Default socks server for the client. */
#undef SOCKS_DEFAULT_SERVER

/* Define this to disable server tcp forwarding (remote forwards). */
#undef SSHD2_TCPFWD_DISABLE

/* Define this if your system has 'machine' field in struct utsname
   (in sys/utsname.h). */
#undef HAVE_MACHINE_IN_UTSNAME

/* Define this if your system has 'domainname' field in struct utsname
   (in sys/utsname.h). */
#undef HAVE_DOMAINNAME_IN_UTSNAME

/* Maximum (hardcoded) number of connections allowed by server
   (0 = unlimited).  Server configuration can't override this limit. */
#undef SSH2_MAX_CONNECTIONS

/* Define this if a prototype for innetgr() is defined in system headers. */
#undef HAVE_PROTO_INNETGR

/* Define this if the system has the loginfailed function to record
   unsuccessful logins */
#undef HAVE_LOGINFAILED

/* Define this to point to your passwd program. */
#undef PASSWD_PATH

/* Define this to point to where sshd2 should store it's pidfile. */
#undef SSHD_PIDDIR





/* Enable the IDEA cipher. */
#undef WITH_IDEA

/* Enable the RSA code. */
#undef WITH_RSA

/* Enable the assembler crypt code. */
#undef WITH_CRYPT_ASM

/* Assember code for Blowfish included. */
#undef ASM_BLOWFISH

/* Assembler code for DES included. */
#undef ASM_DES

/* Assembler code for ARCFOUR included. */
#undef ASM_ARCFOUR

/* Assembler code for MD5 included. */
#undef ASM_MD5

/* Defined if compiled symbols are _not_ prepended with underscore `_' */
#undef HAVE_NO_SYMBOL_UNDERSCORE

/* Define this to use the ANSI X9.17 Random Number Generator */
#undef WITH_ANSI_RNG
@BOTTOM@
#endif /* SSHCONF_H */
