/*

ssh2includes.h

  Authors:
        Tatu Ylonen <ylo@ssh.com>
        Markku-Juhani Saarinen <mjos@ssh.com>
        Timo J. Rinne <tri@ssh.com>
        Sami Lehtinen <sjl@ssh.com>

  Copyright (C) 1997-2000 SSH Communications Security Corp, Helsinki, Finland
  All rights reserved.

*/

#ifndef SSH2INCLUDES_H
#define SSH2INCLUDES_H

#include "sshincludes.h"


#include "sshsessionincludes.h"


#include "ssh2version.h"





















































/* File executed in user's home directory during login. */
#define SSH_USER_RC             "rc"
#define SSH_USER_ENV_FILE       "environment"
#define SSH_SYSTEM_RC           ETCDIR "/sshrc"

#ifndef SSH_SFTP_LOG_FACILITY
#define SSH_SFTP_LOG_FACILITY "SSH2_SFTP_LOG_FACILITY"
#endif /* !SSH_SFTP_LOG_FACILITY */

/* Default tcp/udp port */
#define SSH_DEFAULT_PORT        "22"

/* Definitions for authentication method names. */
#define SSH_AUTH_PUBKEY            "publickey"
#define SSH_AUTH_PASSWD            "password"
#define SSH_AUTH_HOSTBASED         "hostbased"
#define SSH_AUTH_PAM               "pam-1@ssh.com"
#define SSH_AUTH_KERBEROS          "kerberos-2@ssh.com"
#define SSH_AUTH_KERBEROS_TGT      "kerberos-tgt-2@ssh.com"
#define SSH_AUTH_SECURID           "securid-1@ssh.com"
#ifdef SSHDIST_SSH2_AUTH_KBDINTERACTIVE
#define SSH_AUTH_KBD_INTERACTIVE   "keyboard-interactive"
#endif /* SSHDIST_SSH2_AUTH_KBDINTERACTIVE */

/* Path to ssh-signer2 */
#define SSH_SIGNER_PATH       SSH_BINDIR "/ssh-signer2"

/* Path to ssh2 */

#define SSH_SSH2_PATH         SSH_BINDIR "/ssh2"




/* Path to ssh-askpass2 */
#define SSH_ASKPASS_PATH      SSH_BINDIR "/ssh-askpass2"

/* Path to libsocks5.conf */
#define SSH_LIBSOCKS5_CONF_PATH    "/etc/libsocks5.conf"

/* Default idle timeout in seconds for the server. 0 = disabled */
#define SSH_SERVER_DEFAULT_IDLE_TIMEOUT   0




#define SSH2_ADD_GETOPT_ARGS




/* arguments to ssh2 */
#define SSH2_GETOPT_ARGUMENTS "ac:C::vd:e:f::F:h?i:l:L:no:p:PqR:s:" \
                              "StxX8gVkw1:m:64" SSH2_ADD_GETOPT_ARGS

/* protocol version numbers */













#define SSH2_VERSION_STRING "SSH Secure Shell " SSH2_VERSION \
                            " (non-commercial version)"
#define SSH2_PROTOCOL_VERSION_STRING SSH2_VERSION \
                                     " SSH Secure Shell (non-commercial)"



































#endif /* SSH2INCLUDES_H */
