/*
  sshfc_trcore_states.h

  Author: Sami Lehtinen <sjl@ssh.com>

  Copyright (C) 2001, 2002 SSH Communications Security Corp, Helsinki, Finland
  All rights reserved.

  States used by SshFCTransferCore.
 */
/* Include this into a state array. */

#ifdef SSH_FSM_PROTOTYPES
#define SSH_FSM_DECL(x,y,z) SSH_FSM_STEP(z);
#else /* SSH_FSM_PROTOTYPES */
#define SSH_FSM_DECL SSH_FSM_STATE
#endif /* SSH_FSM_PROTOTYPES */

SSH_FSM_DECL("fctc_start_transfer", "Prepare everything for the actual "
             "transfer", transfer_start)

SSH_FSM_DECL("fctc_start_transfer_finalize", "Finalize initialization",
             transfer_start_finalize)

SSH_FSM_DECL("fctc_shred", "Shred file to requests", transfer_shred)

SSH_FSM_DECL("fctc_read_in", "Try to read file", transfer_read_in)

SSH_FSM_DECL("fctc_write_out", "Try to write data to file", transfer_write_out)

SSH_FSM_DECL("fctc_finish", "Finish thread", transfer_core_finish)

SSH_FSM_DECL("fctc_readwrite_error", "Un-recoverable error during actual "
             "transfer", transfer_readwrite_error)

SSH_FSM_DECL("fctc_mangle", "Mangle file", transfer_mangle)

SSH_FSM_DECL("fctc_get_source_newline", "Get source newline convention",
             transfer_get_source_newline_conv)

SSH_FSM_DECL("fctc_get_dest_newline", "Get source dest convention",
             transfer_get_dest_newline_conv)













#undef SSH_FSM_PROTOTYPES
#undef SSH_FSM_DECL
