#ifndef PKCS_CNT
#define PKCS_CNT 10
#endif

extern char *srcpath, filename[128];
extern Boolean verbose;

/* Minimum test time in seconds */
#define TEST_TIME_MIN (getenv("SSH_TIMING") ? atof(getenv("SSH_TIMING")) : 0.3)
/* Optimum test time in milliseconds */
#define TEST_TIME_OPTIMUM       (TEST_TIME_MIN * 1500)
/* Reporting format */
#define TEST_FMT                "%.0f"

void
  test_random(int flags),
  test_hash(int flags),
  test_mac(int flags),
  test_cipher(int flags),
  test_pkcs(int flags);

void tstart(SshTimeMeasure tmit, char *fmt, ...);
void tstop(SshTimeMeasure tmit, char *fmt, ...);

void tstartn(SshTimeMeasure tmit, int total, char *fmt, ...);
int  tstopn(SshTimeMeasure tmit, int total, char *fmt, ...);

void test_random(int flag);

void test_hash(int flag);

void test_mac(int flag);

#define MODE_ECB (1 << 6)
#define MODE_CBC (1 << 7)
#define MODE_CFB (1 << 8)
#define MODE_OFB (1 << 9)
void test_cipher(int flag);

void test_pkcs(int flag);
