/*
 * Author: Tero Kivinen <kivinen@iki.fi>
 * 
 * Copyright (c) 1996 SSH Communications Security Oy <info@ssh.fi>
 */
/*
 *        Program: sshutil
 *        $Source: /ssh/CVS/src/lib/sshutil/sshcore/strncasecmp.c,v $
 *        $Author: fis $
 *
 *        Creation          : 06:56 Aug 20 1996 kivinen
 *        Last Modification : 07:00 Aug 20 1996 kivinen
 *        Last check in     : $Date: 2001/04/24 18:29:55 $
 *        Revision number   : $Revision: 1.3 $
 *        State             : $State: Exp $
 *        Version           : 1.5
 *        
 *
 *        Description       : Replacement functions for strncasecmp
 *
 *
 *        $Log: strncasecmp.c,v $ *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        
 *        $EndLog$
 */

#include "sshincludes.h"

int strncasecmp(const char *s1, const char *s2, size_t len)
{
  if (len==0) 
    return 0;

  while (len-- > 1 && *s1 && (*s1 == *s2 || tolower(*s1) == tolower(*s2)))
    {
      s1++;
      s2++;
    }
  return (int) tolower(*(unsigned char *)s1) 
       - (int) tolower(*(unsigned char *)s2);
}
